#!/usr/bin/python

# Scintilla commands: message codes, used in macros
#INFO, URL=https://www.scintilla.org/CommandValues.html
MACRO_CMDS = {
    2001: 'AddText',  # needs param(s) -> (int length, string text)
    2003: 'InsertText',  # needs param(s) -> (position pos, string text)
    2004: 'ClearAll',
    2013: 'SelectAll',
    2024: 'GotoLine',  # needs param(s) -> (int line,)
    2025: 'GotoPos',  # needs param(s) -> (position caret,)
    2170: 'ReplaceSelection',  # needs param(s) -> (, string text), SPECIAL TREATMENT
    2177: 'Cut',
    2178: 'Copy',
    2179: 'Paste',
    2180: 'Clear',
    2282: 'AppendText',  # needs param(s) -> (int length, string text)
    2300: 'LineDown',
    2301: 'LineDownExtend',
    2302: 'LineUp',
    2303: 'LineUpExtend',
    2304: 'CharLeft',
    2305: 'CharLeftExtend',
    2306: 'CharRight',
    2307: 'CharRightExtend',
    2308: 'WordLeft',
    2309: 'WordLeftExtend',
    2310: 'WordRight',
    2311: 'WordRightExtend',
    2312: 'Home',
    2313: 'HomeExtend',
    2314: 'LineEnd',
    2315: 'LineEndExtend',
    2316: 'DocumentStart',
    2317: 'DocumentStartExtend',
    2318: 'DocumentEnd',
    2319: 'DocumentEndExtend',
    2320: 'PageUp',
    2321: 'PageUpExtend',
    2322: 'PageDown',
    2323: 'PageDownExtend',
    2324: 'EditToggleOvertype',
    2325: 'Cancel',
    2326: 'DeleteBack',
    2327: 'Tab',
    2328: 'BackTab',
    2329: 'NewLine',  # SPECIAL TREATMENT
    2330: 'FormFeed',
    2331: 'VCHome',
    2332: 'VCHomeExtend',
    2335: 'DelWordLeft',
    2336: 'DelWordRight',
    2337: 'LineCut',
    2338: 'LineDelete',
    2339: 'LineTranspose',
    2340: 'LowerCase',
    2341: 'UpperCase',
    2342: 'LineScrollDown',
    2343: 'LineScrollUp',
    2344: 'DeleteBackNotLine',
    2345: 'HomeDisplay',
    2346: 'HomeDisplayExtend',
    2347: 'LineEndDisplay',
    2348: 'LineEndDisplayExtend',
    2349: 'HomeWrap',
    2366: 'SearchAnchor',
    2367: 'SearchNext',  # needs param(s) -> (int searchFlags, string text)
    2368: 'SearchPrev',  # needs param(s) -> (int searchFlags, string text)
    2390: 'WordPartLeft',
    2391: 'WordPartLeftExtend',
    2392: 'WordPartRight',
    2393: 'WordPartRightExtend',
    2395: 'DelLineLeft',
    2396: 'DelLineRight',
    2404: 'LineDuplicate',
    2413: 'ParaDown',
    2414: 'ParaDownExtend',
    2415: 'ParaUp',
    2416: 'ParaUpExtend',
    2422: 'SetSelectionMode',  # needs param(s) -> (int selectionMode,)
    2426: 'LineDownRectExtend',
    2427: 'LineUpRectExtend',
    2428: 'CharLeftRectExtend',
    2429: 'CharRightRectExtend',
    2430: 'HomeRectExtend',
    2431: 'VCHomeRectExtend',
    2432: 'LineEndRectExtend',
    2433: 'PageUpRectExtend',
    2434: 'PageDownRectExtend',
    2435: 'StutteredPageUp',
    2436: 'StutteredPageUpExtend',
    2437: 'StutteredPageDown',
    2438: 'StutteredPageDownExtend',
    2439: 'WordLeftEnd',
    2440: 'WordLeftEndExtend',
    2441: 'WordRightEnd',
    2442: 'WordRightEndExtend',
    2450: 'HomeWrapExtend',
    2451: 'LineEndWrap',
    2452: 'LineEndWrapExtend',
    2453: 'VCHomeWrap',
    2454: 'VCHomeWrapExtend',
    2455: 'LineCopy',
    2469: 'SelectionDuplicate',
    2518: 'DelWordRightEnd',
    2519: 'CopyAllowLine',
    2619: 'VerticalCentreCaret',
    2620: 'MoveSelectedLinesUp',
    2621: 'MoveSelectedLinesDown',
    2628: 'ScrollToStart',
    2629: 'ScrollToEnd',
    2652: 'VCHomeDisplay',
    2653: 'VCHomeDisplayExtend',
}
